# This script will run on any debian base ...

# Making sure that we can compile the source code...
echo "Making sure that we can compile the source code.  Installing/updating build-essential package..."
sudo apt-get install build-essential>/dev/null
RESULT=$?
if [ $RESULT != "0" ]; then
    echo An error occured when installing needed softwares to compile the source code...
    exit;
fi


# Compiling the source code
echo "Now compiling source code.  Please wait..."
sudo make>/dev/null
RESULT=$?
if [ $RESULT != "0" ]; then
    echo An error occured when compiling source code...
    exit;
fi

# if everything when well, we install the module
echo "Now installing new module vloopback into your system..."
sudo make install>/dev/null
RESULT=$?
if [ $RESULT != "0" ]; then
    echo An error occured when installing module...
    exit;
fi

# Ok, modules is not in place
# Now setting the module to auto-load on boot
grep vloopback /etc/modules>/dev/null
RESULT=$?
if [ $RESULT != "0" ]; then
    echo "Installing module vloopback to auto-load on the start-up"
    sudo bash -c "echo #WebcamStudio virtual webcam  >> /etc/modules">/dev/null
    sudo bash -c "echo vloopback >> /etc/modules">/dev/null
    RESULT=$?
    if [ $RESULT != "0" ]; then
	echo An error occured when adding module vloopback to auto-load on boot...
        exit;
    
    fi
else
    echo "Module vloopback already installed to auto-load"
fi

# loading the module for instant use

lsmod | grep vloopback>/dev/null
RESULT=$?
if [ $RESULT == "0" ]; then
    echo "Unloading current vloopback from memory"
    sudo rmmod vloopback>/dev/null
    RESULT=$?
    if [ $RESULT != "0" ]; then
	echo An error occured when unloading  module vloopback...
	exit;
    fi
fi

echo "Loading new module vloopback in memory"
sudo modprobe vloopback>/dev/null
RESULT=$?
if [ $RESULT != "0" ]; then
    echo An error occured when loading module vloopback...
    exit;
fi

# making sure we can read and write
sudo chmod 666 /dev/video*

# Clean-up of compiled binaries...
sudo make clean>/dev/null

# Now it should work
echo "Module vloopback is now installed and ready to use..."

